import Palette from '../model/Palette';

export default class Palettes {
  // https://sourceforge.net/projects/deniseem/
  public static colodore = new Palette([
    [0, 0, 0, 0xff], // black
    [0xff, 0xff, 0xff, 0xff], // white
    [0x81, 0x33, 0x38, 0xff], // red
    [0x75, 0xce, 0xc8, 0xff], // cyan
    [0x8e, 0x3c, 0x97, 0xff], // purple
    [0x56, 0xac, 0x4d, 0xff], // green
    [0x2e, 0x2c, 0x9b, 0xff], // blue
    [0xed, 0xf0, 0x71, 0xff], // yellow
    [0x8e, 0x50, 0x29, 0xff], // orange
    [0x55, 0x38, 0x00, 0xff], // brown
    [0xc4, 0x6c, 0x71, 0xff], // light red
    [0x4a, 0x4a, 0x4a, 0xff], // dark gray
    [0x7b, 0x7b, 0x7b, 0xff], // medium gray
    [0xa9, 0xff, 0x9f, 0xff], // light green
    [0x70, 0x6e, 0xeb, 0xff], // light blue
    [0xb2, 0xb2, 0xb2, 0xff] // light gray
  ]);

  public static pepto = new Palette([
    [0, 0, 0, 0xff], // black
    [0xff, 0xff, 0xff, 0xff], // white
    [0x68, 0x37, 0x2b, 0xff], // red
    [0x70, 0xa4, 0xb2, 0xff], // cyan
    [0x6f, 0x3d, 0x86, 0xff], // purple
    [0x58, 0x8d, 0x43, 0xff], // green
    [0x35, 0x28, 0x79, 0xff], // blue
    [0xb8, 0xc7, 0x6f, 0xff], // yellow
    [0x6f, 0x4f, 0x25, 0xff], // orange
    [0x43, 0x39, 0x00, 0xff], // brown
    [0x9a, 0x67, 0x59, 0xff], // light red
    [0x44, 0x44, 0x44, 0xff], // dark gray
    [0x6c, 0x6c, 0x6c, 0xff], // medium gray
    [0x9a, 0xd2, 0x84, 0xff], // light green
    [0x6c, 0x5e, 0xb5, 0xff], // light blue
    [0x95, 0x95, 0x95, 0xff] // light gray
  ]);

  public static deekay = new Palette([
    [0, 0, 0, 0xff], // black
    [0xff, 0xff, 0xff, 0xff], // white
    [0x88, 0x20, 0x00, 0xff], // red
    [0x68, 0xd0, 0xa8, 0xff], // cyan
    [0xa8, 0x38, 0xa0, 0xff], // purple
    [0x50, 0xb8, 0x43, 0xff], // green
    [0x18, 0x10, 0x90, 0xff], // blue
    [0xf0, 0xe8, 0x58, 0xff], // yellow
    [0xa0, 0x48, 0x00, 0xff], // orange
    [0x47, 0x2b, 0x1b, 0xff], // brown
    [0xc8, 0x78, 0x70, 0xff], // light red
    [0x48, 0x48, 0x48, 0xff], // dark gray
    [0x80, 0x80, 0x80, 0xff], // medium gray
    [0x98, 0xff, 0x98, 0xff], // light green
    [0x50, 0x90, 0xd0, 0xff], // light blue
    [0xb8, 0xb8, 0xb8, 0xff] // light gray
  ]);

  // non c64

  public static spectrumPallete = new Palette([
    [0, 0, 0, 0xff], // black
    [0, 0, 0xd7, 0xff], // blue
    [0xd7, 0, 0, 0xff], // red
    [0xd7, 0, 0xd7, 0xff], // magenta
    [0, 0xd7, 0, 0xff], // green
    [0, 0xd7, 0xd7, 0xff], // green
    [0xd7, 0xd7, 0, 0xff], // yellow
    [0xd7, 0xd7, 0xd7, 0xff], // gray
    [0, 0, 0xff, 0xff], // blue
    [0xff, 0, 0, 0xff], // red
    [0xff, 0, 0xff, 0xff], // magenta
    [0, 0xff, 0, 0xff], // green
    [0, 0xff, 0xff, 0xff], // green
    [0xff, 0xff, 0, 0xff], // yellow
    [0xff, 0xff, 0xff] // white
  ]);

  public static pysslaPalette2 = new Palette([
    [0xc5, 0xdd, 0xdf, 0xff], // white
    [0xeb, 0xae, 0x36, 0xff], // yellow
    [0xb2, 0x48, 0xcf, 0xff], // purple
    [0xd6, 0x00, 0x13, 0xff], // red
    [0x00, 0x80, 0x46, 0xff], // green
    [0xe0, 0x33, 0x1c, 0xff], // orange
    [0x00, 0x7b, 0xb8, 0xff], // blue
    [0xff, 0x00, 0x7f, 0xff], // pink
    [0x4b, 0x21, 0x00, 0xff], // brown
    [0x16, 0x16, 0x16, 0xff] // black
  ]);

  public static pysslaPalette1 = new Palette([
    [0xbd, 0x10, 0x2c, 0xff], // red
    [0x15, 0x62, 0xae, 0xff], // blue
    [0x8e, 0x75, 0xc0, 0xff], // purple
    [0xf3, 0x35, 0xb7, 0xff], // pink
    [0xd3, 0xd3, 0xd3, 0xff], // white
    [0x06, 0x4b, 0x21, 0xff], // green
    [0xe6, 0xa7, 0x21, 0xff], // yellow
    [0x27, 0x1b, 0x25, 0xff], // brown
    [0xda, 0x2a, 0x2a, 0xff], // orange
    [0x13, 0x13, 0x13, 0xff] // black
  ]);

  public static all = {
    pepto: Palettes.pepto,
    colodore: Palettes.colodore,
    deekay: Palettes.deekay
  };
}
